# カラーひよこ
# (c) シオビ	http://www.siobi.info/

# 陰陽の色を直接設定し、通常の設定では作れない色を作成します。
#
# 2009/09/09 (ver. 2.10) UUIDを利用しようとしたが中止。誤字修正。ダイアログを改良。
# 2009/07/18 (ver. 2.00) Pythonに移植。
# 2002/12/27 (ver. 1.00) Tcl版作成。[2002/12/27～2006/03/21]


SCRIPT_ID = 0x51081A01


# 関数
def colorant(scene):

	# ダイアログ
	dialog = xshade.create_dialog(SCRIPT_ID)
#	dialog = xshade.create_dialog_with_uuid('51081A00-2003-0903-0409-51081B000001')
	dialog.begin_group('色')
	index_color_sun   = dialog.append_rgb("陽の色")
	index_color_shade = dialog.append_rgb("陰の色")
	dialog.end_group()
	dialog.append_default_button()

	dialog.set_default_value(index_color_sun, [1.00, 1.00, 1.00])
	dialog.set_default_value(index_color_shade, [1.00, 0.00, 0.50])

	if not dialog.ask("カラーひよこ"):
		return False

	color_sun	= dialog.get_value(index_color_sun)
	color_shade	= dialog.get_value(index_color_shade)


	try:
		# 色を計算
		color_diffuse = [0, 0, 0]
		for color in range(3):
			color_diffuse[color] = color_sun[color] - color_shade[color]

		# 着色
		xshade.scene().active_shape().has_surface_attributes = 1
		xshade.scene().active_shape().surface.has_diffuse 	= 1
		xshade.scene().active_shape().surface.diffuse_color = [color_diffuse[0], color_diffuse[1], color_diffuse[2]]
		xshade.scene().active_shape().surface.glow			= 1.000
		xshade.scene().active_shape().surface.glow_color	= [color_shade[0], color_shade[1], color_shade[2]]

		# メッセージ
		print ""
		print "陽の色： RGB = (%4d,%4d,%4d)" % (color_sun[0]*255,   color_sun[1]*255,   color_sun[2]*255)
		print "陰の色： RGB = (%4d,%4d,%4d)" % (color_shade[0]*255, color_shade[1]*255, color_shade[2]*255)
		print "設定しました。"

		# 画面を更新
		xshade.scene().update_figure_window()

	except:
		print "予期せぬエラーが発生しました"


can_import = True
try:
	import random
except:
	print "Pythonがインストールされていません"
	can_import = False

if can_import:
	colorant(xshade.scene())

